<?php

namespace Picea\Ui\Form;

use Picea\Ui\Common\UiElement;
use Picea\Extension\Extension;
use Picea\Extension\ExtensionTrait;

class UiInput extends UiElement implements Extension {
    use ExtensionTrait;

    public string $token = "ui.input";

    public string $tag = "input";

    public array $attributes = [
       'class' => 'ui-input',
    ];

    public function parse(/*\Picae\Compiler\Context*/ &$context, ?string $arguments, string $token) : string
    {
        return "<?php echo ( new \\" . static::class . "() )->buildHtml($arguments) ?>";
    }

    public function buildHtml(string $name, ? string $value = null, array $attributes = []) : string
    {
        $this->setValue($value);
        $this->attributes([ 'name' => $name ] + $attributes + $this->attributes);
        
        return $this->render();
    }

    protected function setValue($value) : void
    {
        $this->attributes['value'] = $value;
    }

}
