<?php

namespace Picea\Ui\Method;

use Psr\Http\Message\ServerRequestInterface;

class FormHandler {
    # return new class($this->request, new FormContext(), $form) {

    public bool $sent = false;
    
    public FormContext $context;

    protected ServerRequestInterface $request;

    protected FormInterface $form;

    public function __construct(ServerRequestInterface $request, FormInterface $form, ? FormContextInterface $context = null)
    {
        $this->request = $request;
        $this->sent = $this->requestSent();
        $this->form = $form;
        $this->context = $context ?: new FormContext($request);
        $this->context->formSent = $this->sent;
        $this->initialize();
    }

    protected function initialize() : void
    {
        $this->form->initialize($this->context);

        if ( $this->sent ) {
            if ( $this->form->validate($this->context) ) {
                $this->form->save($this->context);
            }
        }
    }

    protected function requestSent() : bool
    {
        return in_array($this->request->getMethod(), [
            "DELETE", "PATCH", "POST", "PUT",
        ]);
    }

    protected function honeyPot() : bool
    {
        $this->request->getServerParams();
    }
}
